# List bill runs Lists bill runs. You can use the query parameters to filter, expand, and sort the returned results. Endpoint: GET /object-query/billing-runs Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Query parameters: - `pageSize` (integer) The maximum number of results to return in a single page. If the specified pageSize is less than 1 or greater than 99, Zuora will return a 400 error. - `cursor` (string) A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with next_page=W3sib3JkZXJ=, your subsequent call can include cursor=W3sib3JkZXJ= in order to fetch the next page of the list. - `sort[]` (array) A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. accountnumber.ASC) or descending (e.g. accountnumber.DESC). You cannot sort on properties in arrays. If the array-type properties are specified for the sort[] parameter, they are ignored. Supported sortable fields: - id - createdbyid - updateddate - billingrunnumber - executeddate - name - numberofaccounts - numberofinvoices - numberofcreditmemos - status - targetdate - batches - repeattype - `expand[]` (array) Allows you to expand responses by including related object information in a single call. The Bill Run object does not support expanding any related objects. - `filter[]` (array) A case-insensitive filter on the list. Supported filterable fields: - id - createdbyid - updateddate - billingrunnumber - executeddate - name - numberofaccounts - numberofinvoices - numberofcreditmemos - status - targetdate - batches - repeattype - {indexedcustomfield}: Use the format like customField__c to filter on custom fields. - `fields[]` (array) A case-insensitive query parameter that allows you to specify which fields are returned in the response. Example: "id,createddate" - `includeNullFields` (boolean) Specifies whether to include fields with the null value in the response. - If set to true, all fields will be returned in the response, including those with the null value. - If set to false, only fields with non-null values will be returned. ## Response 200 fields (application/json): - `nextPage` (string,null) A string that can be used as the cursor value to retrieve the next page of the response if it exists; otherwise absent. - `data` (array) - `data.id` (string) The unique identifier of the bill run. - `data.createdById` (string) The unique identifier of the user who created the bill run. - `data.createdDate` (string) The date and time when the bill run was created. - `data.updatedById` (string) The unique identifier of the user who last updated the bill run. - `data.updatedDate` (string) The date and time when the bill run was last updated. - `data.billingRunNumber` (string) The number of the bill run. - `data.billingRunType` (string) The type of the bill run. - You can use this field only if the Catch-Up Bill Run feature is enabled. - You must specify this field to create a catch up bill run. Enum: "Regular", "CatchUp" - `data.endDate` (string) The end date and time when the bill run completes. - `data.errorMessage` (string) The error message generated by a failed billing run. - `data.executedDate` (string) The date and time when the bill run was executed. - `data.invoiceDate` (string) The date that appears on the invoice being created, in the yyyy-mm-dd format. The value cannot fall in a closed accounting period. - `data.name` (string) The name of the bill run. - `data.numberOfAccounts` (integer) The number of accounts included in this bill run processing. - `data.numberOfInvoices` (integer) The number of invoices generated from this bill run. - `data.numberOfCreditMemos` (integer) The number of credit memos generated from this bill run. - `data.postedDate` (string) The date when the bill run was posted. - `data.startDate` (string) The start date and time of the bill run. - `data.status` (string) The status of the bill run. Enum: "Pending", "Processing", "Completed", "Error", "Canceled", "Posted", "PostInProgress", "CancelInProgress", "RemoveInProgress", "Paused" - `data.targetDate` (string) The target date for this bill run, only valid for ad-hoc bill runs. - `data.targetType` (string) The target type for this bill run. Enum: "SingleAccount", "AllAccount" - `data.totalTime` (integer) The total time in milliseconds for the bill run to complete. - `data.accountId` (string) The unique identifier of the account included in the bill run. - `data.batches` (array) The batch of accounts for this bill run, this field can not exist with billRunFilters together. Values: AllBatches or an array of Batchn where n is a number between 1 and 50, for example, Batch7. - `data.billCycleDay` (string) The day of the bill cycle. This field is only valid when batches is specified. Values: - AllBillCycleDays or one of numbers 1 - 31 for an ad-hoc bill run - AllBillCycleDays, one of numbers 1 - 31, or AsRunDay for a scheduled bill run Enum: "AllBillCycleDays", "AsRunDay" - `data.noEmailForZeroAmountInvoice` (boolean) Whether to suppress emails for invoices with zero total amount generated in this bill run after the bill run is complete. - `data.autoEmail` (boolean) Whether to automatically send emails after Auto-Post is complete. - `data.autoPost` (boolean) Whether to automatically post the bill run after the bill run is created. - `data.autoRenewal` (boolean) Whether to automatically renew auto-renew subscriptions that are up for renewal. - `data.invoicesEmailed` (boolean) Whether the invoices have been emailed after the bill run is complete. - `data.lastEmailSentTime` (string) The date and time when the last email was sent. - `data.targetDateOffSet` (integer) The offset compared to bill run execution date, only valid for scheduled bill runs. - `data.invoiceDateOffSet` (integer) The offset compared to bill run execution date, only valid for scheduled bill runs. - `data.chargeTypeToExclude` (string) The types of the charges to be excluded from the generation of billing documents. Enum: "OneTime", "Recurring", "Usage" - `data.scheduledExecutionTime` (string) The scheduled execution time for a bill run. - `data.repeatType` (string) The repeat type of the bill run. Enum: "None", "Daily", "Weekly", "Monthly" - `data.repeatFrom` (string) The start date of the scheduled bill run. - `data.repeatTo` (string) The end date of of the scheduled bill run. - `data.runTime` (integer) The scheduled run time (hour) of day. - `data.timeZone` (string) Timezone of the scheduled bill run. - `data.monthlyOnDay` (string) The repeat day in a month. - `data.weeklyOnDay` (string) The repeat day in a week. Enum: "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun" - `data.includeSubscriptions` (boolean) Indicates whether to bill subscriptions in the bill run. - `data.includeOrderLineItems` (boolean) Indicates whether to bill order line items in the bill run. ## Response 500 fields (application/json): - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (integer) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) The unique identifier of the request. ## Response 4XX fields (application/json): - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (integer) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) The unique identifier of the request.